Feature # 801 (Resolved): librados: allow access to multiple clusters
Remove globals & partition g_conf
Description

This bug is to track the progress of removing globals and setting up g_conf so it can be used as a parameter rather than a global.

Subtasks:

Subtask # 839: Globals cleanup. Replace g_conf.name with g_conf.entity_name.to_str(). R... Resolved
Subtask # 840: Clean separation between different components of initialization Resolved
Subtask # 841: don't call daemon_init in library code Resolved
Subtask # 842: initialization: have appropriate library-specific defaults Resolved
Subtask # 843: Decouple dout from g_conf Resolved
Subtask # 844: g_conf should become a pointer Resolved
Subtask # 845: g_conf should not be defined in library code. Resolved
Subtask # 846: De-globalize SimpleMessenger, etc. Resolved
Subtask # 1160: introduce CephContext to some structures in common/ Resolved
Subtask # 1164: initialize g_ceph_context in common_preinit Resolved
Subtask # 1227: write tests of libceph, librgw, librados library thread-safety Rejected
Subtask # 1231: NUM_THREADS=3 testrados segfaults Rejected
History

#1 - 02/17/2011 09:11 AM - Greg Farnum

So one issue that occurred to me with setting this up is that we have a number of things that really ought to be globals. For instance, right now the
SimpleMessenger can take a single Throttler and use that to restrict the flow of incoming and outgoing messages based on config options in g_conf.
While it's good to remove the globals, it's entirely possible that clients will have connections to multiple clusters but still want to have a total limit on
how much memory is devoted to caching messages. We'll need some way of implementing that!

#2 - 02/17/2011 02:21 PM - Colin McCabe

Good point. Some things probably should be global. However, we have a lot of things that library clients don't want to be global as globals now.
That's the problem.

Also, even things that should be global, it's not good to have global constructors that do a lot of work. Global constructor time is scary.

#3 - 03/07/2011 10:42 AM - Colin McCabe
- Target version changed from 12 to v0.26

- Estimated time set to 0.00 h

#4 - 06/20/2011 12:06 PM - Sage Weil
- Estimated time set to 0.00 h

#5 - 07/05/2011 09:30 AM - Colin McCabe
- Status changed from In Progress to Resolved

- Estimated time set to 0.00 h

This bug was really all about refactoring stuff to be thread-safe. Now, that task has been completed.
It's time to start testing and fixing any issues that were uncovered. That will be done in bug #1257.

Colin.
